/* -*- Mode: C; tab-width: 8; indent-tabs-mode: t; c-basic-offset: 8 -*- */
#ifndef __NUMEXP_CLIENT1_H__
#define __NUMEXP_CLIENT1_H__

#include <libbonobo.h>
#include <glib.h>
#include "Numexp_Kernel.h"

G_BEGIN_DECLS

#define NUMEXP_CLIENT_TYPE         (numexp_client_get_type ())
#define NUMEXP_CLIENT(o)           (G_TYPE_CHECK_INSTANCE_CAST ((o), NUMEXP_CLIENT_TYPE, NumexpClient))
#define NUMEXP_CLIENT_CLASS(k)     (G_TYPE_CHECK_CLASS_CAST((k), NUMEXP_CLIENT_TYPE, NumexpClientClass))
#define NUMEXP_CLIENT_IS_OBJECT(o) (G_TYPE_CHECK_INSTANCE_TYPE ((o), NUMEXP_CLIENT_TYPE))
#define NUMEXP_CLIENT_IS_CLASS(k)  (G_TYPE_CHECK_CLASS_TYPE ((k), NUMEXP_CLIENT_TYPE))
#define NUMEXP_CLIENT_GET_CLASS(o) (G_TYPE_INSTANCE_GET_CLASS ((o), NUMEXP_CLIENT_TYPE, NumexpClientClass))

typedef struct _NumexpClient		NumexpClient;
typedef struct _NumexpClientClass	NumexpClientClass;



struct _NumexpClient {
	BonoboObject   parent;
	Numexp_Kernel  kernel;
	char          *cwd;
	GHashTable    *completions;
};

struct _NumexpClientClass {
	BonoboObjectClass parent_class;

	POA_Numexp_Client__epv epv;
};


GType         numexp_client_get_type              (void);
BonoboObject* numexp_client_new                   (void);
void          numexp_client_get_completions       (NumexpClient  *self,
						   const char    *ns);
void          nxp_client_completion_init          (NumexpClient  *self);
void          nxp_client_completion_new_namespace (NumexpClient  *self,
						   const char    *ns);
void          nxp_client_completion_add_items     (NumexpClient  *self,
						   const char    *ns,
						   GList         *l);
GList*        nxp_client_completion_complete      (char const    *text,
						   char         **prefix);


G_END_DECLS

#endif /* __NUMEXP_CLIENT_H1__ */
